#include "StdIo.h"
#include "StdLib.h"

int main (int argc, char **argv) {
    unsigned i, j;
    FILE     *exefile;
    if (argc == 2) {
        exefile = fopen (argv[1], "rb");
        if (exefile) {
            printf ("Checking file %s...\n", argv[1]);
            j = 0;
            fseek (exefile, 0x7c, SEEK_SET);
            fread (&i, 4, 1, exefile);
            printf ("Original checksum was %x\n", i);
            while (!feof (exefile)) {
                fread (&i, 4, 1, exefile);
                j ^= i;
            }
            fclose (exefile);
            exefile = fopen (argv[1], "r+b");
            if (exefile) {
                printf ("Checksum %x added.\n", j);
                fseek  (exefile, 0x7c, SEEK_SET);
                fwrite (&j, 4, 1, exefile);
                fclose (exefile);
            }
        } else {
            printf ("File %s not found.\n", argv[1]);
        }
    }
	return 0;
}

